using System;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Direct3D=Microsoft.DirectX.Direct3D;
using System.Collections.Generic;
using System.Collections;
using System.Text;

namespace Object3DLibrary
{


    //3DIuWFNgNX
    //Xfile
    class Object3D
    {
        //3DɎg
        Mesh _mesh;
        Texture[] _textures;
        Material[] _materials;
        int _iMaterialLength;



        //RXgN^
        public Object3D(string XFileName, Device dev)
        {
            ExtendedMaterial[] materialsEx = null;


            try
            {
                // Load the mesh from the specified file
                _mesh = Mesh.FromFile(XFileName, MeshFlags.SystemMemory, dev, out materialsEx);
            }
            catch (DirectXException)
            {
                return;
            }


            //}eA
            _materials = new Direct3D.Material[materialsEx.Length];

            //Ƃ肠}eǍeNX`Ƃ
            _textures = new Texture[materialsEx.Length];

            for (int i = 0; i < materialsEx.Length; i++)
            {
                _materials[i] = materialsEx[i].Material3D;//}eÃRs[

                // Set the ambient color for the material (D3DX does not do this)
                _materials[i].Ambient = _materials[i].Diffuse;

                //eNX`g@e}eA1̃eNX`̂ݎg(eNX`Xe[W0̂ݎgp)
                if (materialsEx[i].TextureFilename != null)
                    _textures[i] = TextureLoader.FromFile(dev, materialsEx[i].TextureFilename);
            }

            //Rs[Ƃ
            _iMaterialLength = materialsEx.Length;
        }

        //}eA̐ݒ
        public void SetMaterials(Material[] materials)
        { 
            if(_materials.Length != materials.Length)
                return;

            for(int i = 0; i < _materials.Length; i++)
            {
                //}eÃRs[
                _materials[i].Diffuse = materials[i].Diffuse;
            }
        }

        //`
        public void Draw(Matrix mat, Device dev)
        {
            dev.Transform.World = mat;



            for (int i = 0; i < _iMaterialLength; i++)
            {
                // Set the material and texture for this subset
                dev.Material = _materials[i];
                //
                if (_textures[i] != null)
                    dev.SetTexture(0, _textures[i]);

                // Draw the mesh subset
                _mesh.DrawSubset(i);
            }
        }
    }



    class ObjectLibrary
    {
        Device _dev;

        //RXgN^
        public ObjectLibrary(Device dev)
        { 
            _dev = dev;
        }

        //IuWFNgl܂Ă
        Hashtable _objectsTable = new Hashtable();


        //t@CIuWFNgǂݏo
        //IuWFNg͑Ήt閼Onull̂Ƃt@CƓƂȂ
        public void AddLoadObject(String XFileName,String ObjectName)
        {
            //JgfBNg̐ݒ
            Directory.SetCurrentDirectory(Application.StartupPath + @"\..\..\");

            //IuWFNg̍쐬
            Object3D obj = new Object3D(XFileName, _dev);

            //nbVe[up̖O
            String name = ObjectName;
            if (name == null)
                name = XFileName;

            _objectsTable.Add(name,obj);
        }

        //OIuWFNgQƂ
        public Object3D GetObject(String ObjectName)
        {
            if (_objectsTable.Contains(ObjectName))
            {
                return (Object3D)_objectsTable[ObjectName];
            }else{
                return null;
            }
        
        }

    }
}
